/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package vip.xiaonuo.modular.bi.pigsemen.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollStreamUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import vip.xiaonuo.common.enums.CommonSortOrderEnum;
import vip.xiaonuo.common.exception.CommonException;
import vip.xiaonuo.common.page.CommonPageRequest;
import vip.xiaonuo.modular.bi.pigsemen.entity.PigSemen;
import vip.xiaonuo.modular.bi.pigsemen.mapper.PigSemenMapper;
import vip.xiaonuo.modular.bi.pigsemen.param.PigSemenAddParam;
import vip.xiaonuo.modular.bi.pigsemen.param.PigSemenEditParam;
import vip.xiaonuo.modular.bi.pigsemen.param.PigSemenIdParam;
import vip.xiaonuo.modular.bi.pigsemen.param.PigSemenPageParam;
import vip.xiaonuo.modular.bi.pigsemen.service.PigSemenService;

import java.util.Date;
import java.util.List;

/**
 * 采精信息Service接口实现类
 *
 * @author wang
 * @date  2023/12/08 10:22
 **/
@Service
public class PigSemenServiceImpl extends ServiceImpl<PigSemenMapper, PigSemen> implements PigSemenService {

    @Override
    public Page<PigSemen> page(PigSemenPageParam pigSemenPageParam) {
        QueryWrapper<PigSemen> queryWrapper = new QueryWrapper<>();
        if(ObjectUtil.isNotEmpty(pigSemenPageParam.getEartag())) {
            queryWrapper.lambda().like(PigSemen::getEartag, pigSemenPageParam.getEartag());
        }
        if(ObjectUtil.isNotEmpty(pigSemenPageParam.getStartCollectSemenDate()) && ObjectUtil.isNotEmpty(pigSemenPageParam.getEndCollectSemenDate())) {
            queryWrapper.lambda().between(PigSemen::getCollectSemenDate, pigSemenPageParam.getStartCollectSemenDate(), pigSemenPageParam.getEndCollectSemenDate());
        }
        if(ObjectUtil.isAllNotEmpty(pigSemenPageParam.getSortField(), pigSemenPageParam.getSortOrder())) {
            CommonSortOrderEnum.validate(pigSemenPageParam.getSortOrder());
            queryWrapper.orderBy(true, pigSemenPageParam.getSortOrder().equals(CommonSortOrderEnum.ASC.getValue()),
                    StrUtil.toUnderlineCase(pigSemenPageParam.getSortField()));
        } else {
            queryWrapper.lambda().orderByAsc(PigSemen::getId);
        }
        return this.page(CommonPageRequest.defaultPage(), queryWrapper);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void add(PigSemenAddParam pigSemenAddParam) {
        PigSemen pigSemen = BeanUtil.toBean(pigSemenAddParam, PigSemen.class);
        pigSemen.setCreateDate(new Date());
        this.save(pigSemen);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void edit(PigSemenEditParam pigSemenEditParam) {
        PigSemen pigSemen = this.queryEntity(pigSemenEditParam.getId());
        BeanUtil.copyProperties(pigSemenEditParam, pigSemen);
        this.updateById(pigSemen);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void delete(List<PigSemenIdParam> pigSemenIdParamList) {
        // 执行删除
        this.removeByIds(CollStreamUtil.toList(pigSemenIdParamList, PigSemenIdParam::getId));
    }

    @Override
    public PigSemen detail(PigSemenIdParam pigSemenIdParam) {
        return this.queryEntity(pigSemenIdParam.getId());
    }

    @Override
    public PigSemen queryEntity(Integer id) {
        PigSemen pigSemen = this.getById(id);
        if(ObjectUtil.isEmpty(pigSemen)) {
            throw new CommonException("采精信息不存在，id值为：{}", id);
        }
        return pigSemen;
    }
}
